Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaPropertyImpl.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaPropertyImpl.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaPropertyImpl.java	(revision 511)
@@ -46,5 +46,4 @@
  *   <li>{@link org.modelica.uml.sysml.impl.ModelicaPropertyImpl#getArrayDimension <em>Array Dimension</em>}</li>
  *   <li>{@link org.modelica.uml.sysml.impl.ModelicaPropertyImpl#getAccess <em>Access</em>}</li>
- *   <li>{@link org.modelica.uml.sysml.impl.ModelicaPropertyImpl#getDataType <em>Data Type</em>}</li>
  * </ul>
  * </p>
@@ -163,14 +162,4 @@
 
 	/**
-	 * The cached value of the '{@link #getDataType() <em>Data Type</em>}' reference.
-	 * <!-- begin-user-doc -->
-	 * <!-- end-user-doc -->
-	 * @see #getDataType()
-	 * @generated
-	 * @ordered
-	 */
-	protected ModelicaClassifier dataType = null;
-
-	/**
 	 * <!-- begin-user-doc --> <!-- end-user-doc -->
 	 * @generated
@@ -187,33 +176,41 @@
 			return;
 		}
-
+/*
 		if (this.getType() instanceof ModelicaType) {
 			this.getType().destroy();
 		}
-
+*/
 		Type typeInstance = newType;
 		if (newType instanceof PrimitiveType
 				&& newType.getName().equals("Real")) {
+			if(!(typeInstance instanceof ModelicaReal)){
 			ModelicaReal realType = SysmlFactory.eINSTANCE.createModelicaReal();
 			typeInstance = newType.getModel().createOwnedType("Real",
 					realType.eClass());
+			}
 		} else if (newType instanceof PrimitiveType
 				&& newType.getName().equals("String")) {
+			if(!(typeInstance instanceof ModelicaString)){
 			ModelicaString stringType = SysmlFactory.eINSTANCE
 					.createModelicaString();
 			typeInstance = newType.getModel().createOwnedType("String",
 					stringType.eClass());
+			}
 		} else if (newType instanceof PrimitiveType
 				&& newType.getName().equals("Boolean")) {
+			if(!(typeInstance instanceof ModelicaBoolean)){
 			ModelicaBoolean booleanType = SysmlFactory.eINSTANCE
 					.createModelicaBoolean();
 			typeInstance = newType.getModel().createOwnedType("Boolean",
 					booleanType.eClass());
+			}
 		} else if (newType instanceof PrimitiveType
 				&& newType.getName().equals("Integer")) {
+			if(!(typeInstance instanceof ModelicaInteger)){
 			ModelicaInteger integerType = SysmlFactory.eINSTANCE
 					.createModelicaInteger();
 			typeInstance = newType.getModel().createOwnedType("Integer",
 					integerType.eClass());
+			}
 		}
 
@@ -341,42 +338,4 @@
 		if (eNotificationRequired())
 			eNotify(new ENotificationImpl(this, Notification.SET, SysmlPackage.MODELICA_PROPERTY__ACCESS, oldAccess, access));
-	}
-
-	/**
-	 * <!-- begin-user-doc -->
-	 * <!-- end-user-doc -->
-	 * @generated
-	 */
-	public ModelicaClassifier getDataType() {
-		if (dataType != null && dataType.eIsProxy()) {
-			InternalEObject oldDataType = (InternalEObject)dataType;
-			dataType = (ModelicaClassifier)eResolveProxy(oldDataType);
-			if (dataType != oldDataType) {
-				if (eNotificationRequired())
-					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SysmlPackage.MODELICA_PROPERTY__DATA_TYPE, oldDataType, dataType));
-			}
-		}
-		return dataType;
-	}
-
-	/**
-	 * <!-- begin-user-doc -->
-	 * <!-- end-user-doc -->
-	 * @generated
-	 */
-	public ModelicaClassifier basicGetDataType() {
-		return dataType;
-	}
-
-	/**
-	 * <!-- begin-user-doc -->
-	 * <!-- end-user-doc -->
-	 * @generated
-	 */
-	public void setDataType(ModelicaClassifier newDataType) {
-		ModelicaClassifier oldDataType = dataType;
-		dataType = newDataType;
-		if (eNotificationRequired())
-			eNotify(new ENotificationImpl(this, Notification.SET, SysmlPackage.MODELICA_PROPERTY__DATA_TYPE, oldDataType, dataType));
 	}
 
@@ -399,7 +358,4 @@
 			case SysmlPackage.MODELICA_PROPERTY__ACCESS:
 				return getAccess();
-			case SysmlPackage.MODELICA_PROPERTY__DATA_TYPE:
-				if (resolve) return getDataType();
-				return basicGetDataType();
 		}
 		return super.eGet(featureID, resolve, coreType);
@@ -430,7 +386,4 @@
 				setAccess((AccessKind)newValue);
 				return;
-			case SysmlPackage.MODELICA_PROPERTY__DATA_TYPE:
-				setDataType((ModelicaClassifier)newValue);
-				return;
 		}
 		super.eSet(featureID, newValue);
@@ -460,7 +413,4 @@
 			case SysmlPackage.MODELICA_PROPERTY__ACCESS:
 				setAccess(ACCESS_EDEFAULT);
-				return;
-			case SysmlPackage.MODELICA_PROPERTY__DATA_TYPE:
-				setDataType((ModelicaClassifier)null);
 				return;
 		}
@@ -486,6 +436,4 @@
 			case SysmlPackage.MODELICA_PROPERTY__ACCESS:
 				return access != ACCESS_EDEFAULT;
-			case SysmlPackage.MODELICA_PROPERTY__DATA_TYPE:
-				return dataType != null;
 		}
 		return super.eIsSet(featureID);
Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaRealImpl.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaRealImpl.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaRealImpl.java	(revision 511)
@@ -37,5 +37,5 @@
  * @generated
  */
-public class ModelicaRealImpl extends ModelicaTypeImpl implements ModelicaReal {
+public class ModelicaRealImpl extends ModelicaPrimitiveTypeImpl implements ModelicaReal {
 	/**
 	 * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaStringImpl.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaStringImpl.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaStringImpl.java	(revision 511)
@@ -30,5 +30,5 @@
  * @generated
  */
-public class ModelicaStringImpl extends ModelicaTypeImpl implements ModelicaString {
+public class ModelicaStringImpl extends ModelicaPrimitiveTypeImpl implements ModelicaString {
 	/**
 	 * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaTypeImpl.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaTypeImpl.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/ModelicaTypeImpl.java	(revision 511)
@@ -7,5 +7,18 @@
 package org.modelica.uml.sysml.impl;
 
+import org.eclipse.emf.common.notify.Notification;
+import org.eclipse.emf.common.notify.NotificationChain;
+
 import org.eclipse.emf.ecore.EClass;
+import org.eclipse.emf.ecore.EObject;
+
+import org.eclipse.emf.ecore.InternalEObject;
+
+import org.eclipse.emf.ecore.impl.ENotificationImpl;
+
+import org.eclipse.uml2.uml.PrimitiveType;
+import org.eclipse.uml2.uml.Type;
+
+import org.eclipse.uml2.uml.Classifier;
 
 import org.eclipse.uml2.uml.internal.impl.PrimitiveTypeImpl;
@@ -13,5 +26,10 @@
 import org.eclipse.uml2.uml.internal.impl.DataTypeImpl;
 
+import org.modelica.uml.sysml.ModelicaBoolean;
+import org.modelica.uml.sysml.ModelicaInteger;
+import org.modelica.uml.sysml.ModelicaReal;
+import org.modelica.uml.sysml.ModelicaString;
 import org.modelica.uml.sysml.ModelicaType;
+import org.modelica.uml.sysml.SysmlFactory;
 import org.modelica.uml.sysml.SysmlPackage;
 
@@ -21,9 +39,23 @@
  * <!-- end-user-doc -->
  * <p>
+ * The following features are implemented:
+ * <ul>
+ *   <li>{@link org.modelica.uml.sysml.impl.ModelicaTypeImpl#getTypeData <em>Type Data</em>}</li>
+ * </ul>
  * </p>
  *
  * @generated
  */
-public class ModelicaTypeImpl extends PrimitiveTypeImpl implements ModelicaType {
+public class ModelicaTypeImpl extends ModelicaClassifierImpl implements ModelicaType {
+	/**
+	 * The cached value of the '{@link #getTypeData() <em>Type Data</em>}' containment reference.
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @see #getTypeData()
+	 * @generated
+	 * @ordered
+	 */
+	protected PrimitiveType typeData = null;
+
 	/**
 	 * <!-- begin-user-doc -->
@@ -44,3 +76,153 @@
 	}
 
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public PrimitiveType getTypeData() {
+		return typeData;
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public NotificationChain basicSetTypeData(PrimitiveType newTypeData, NotificationChain msgs) {
+		PrimitiveType oldTypeData = typeData;
+		typeData = newTypeData;
+		if (eNotificationRequired()) {
+			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SysmlPackage.MODELICA_TYPE__TYPE_DATA, oldTypeData, newTypeData);
+			if (msgs == null) msgs = notification; else msgs.add(notification);
+		}
+		return msgs;
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated NOT
+	 */
+	public void setTypeData(PrimitiveType newTypeData) {
+		
+		if(newTypeData == null)
+			return;
+		
+		Type typeInstance = newTypeData;
+		if (newTypeData instanceof PrimitiveType
+				&& newTypeData.getName().equals("Real")) {
+			if(!(typeInstance instanceof ModelicaReal)){
+			ModelicaReal realType = SysmlFactory.eINSTANCE.createModelicaReal();
+			typeInstance = newTypeData.getModel().createOwnedType("Real",
+					realType.eClass());
+			}
+		} else if (newTypeData instanceof PrimitiveType
+				&& newTypeData.getName().equals("String")) {
+			if(!(typeInstance instanceof ModelicaString)){
+			ModelicaString stringType = SysmlFactory.eINSTANCE
+					.createModelicaString();
+			typeInstance = newTypeData.getModel().createOwnedType("String",
+					stringType.eClass());
+			}
+		} else if (newTypeData instanceof PrimitiveType
+				&& newTypeData.getName().equals("Boolean")) {
+			if(!(typeInstance instanceof ModelicaBoolean)){
+			ModelicaBoolean booleanType = SysmlFactory.eINSTANCE
+					.createModelicaBoolean();
+			typeInstance = newTypeData.getModel().createOwnedType("Boolean",
+					booleanType.eClass());
+			}
+		} else if (newTypeData instanceof PrimitiveType
+				&& newTypeData.getName().equals("Integer")) {
+			if(!(typeInstance instanceof ModelicaInteger)){
+			ModelicaInteger integerType = SysmlFactory.eINSTANCE
+					.createModelicaInteger();
+			typeInstance = integerType;
+			typeInstance = newTypeData.getModel().createOwnedType("Integer",
+				integerType.eClass());
+			}
+		}
+
+		
+		if (typeInstance != typeData) {
+			NotificationChain msgs = null;
+			/*if (typeData != null)
+				msgs = ((InternalEObject)typeData).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SysmlPackage.MODELICA_TYPE__TYPE_DATA, null, msgs);
+			if (typeInstance != null)
+				msgs = ((InternalEObject)newTypeData).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SysmlPackage.MODELICA_TYPE__TYPE_DATA, null, msgs);*/
+			msgs = basicSetTypeData((PrimitiveType)typeInstance, msgs);
+			if (msgs != null) msgs.dispatch();
+		}
+		else if (eNotificationRequired())
+			eNotify(new ENotificationImpl(this, Notification.SET, SysmlPackage.MODELICA_TYPE__TYPE_DATA, typeInstance, typeInstance));
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
+		switch (featureID) {
+			case SysmlPackage.MODELICA_TYPE__TYPE_DATA:
+				return basicSetTypeData(null, msgs);
+		}
+		return super.eInverseRemove(otherEnd, featureID, msgs);
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public Object eGet(int featureID, boolean resolve, boolean coreType) {
+		switch (featureID) {
+			case SysmlPackage.MODELICA_TYPE__TYPE_DATA:
+				return getTypeData();
+		}
+		return super.eGet(featureID, resolve, coreType);
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public void eSet(int featureID, Object newValue) {
+		switch (featureID) {
+			case SysmlPackage.MODELICA_TYPE__TYPE_DATA:
+				setTypeData((PrimitiveType)newValue);
+				return;
+		}
+		super.eSet(featureID, newValue);
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public void eUnset(int featureID) {
+		switch (featureID) {
+			case SysmlPackage.MODELICA_TYPE__TYPE_DATA:
+				setTypeData((PrimitiveType)null);
+				return;
+		}
+		super.eUnset(featureID);
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public boolean eIsSet(int featureID) {
+		switch (featureID) {
+			case SysmlPackage.MODELICA_TYPE__TYPE_DATA:
+				return typeData != null;
+		}
+		return super.eIsSet(featureID);
+	}
+
 } //ModelicaTypeImpl
Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/SysmlFactoryImpl.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/SysmlFactoryImpl.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/SysmlFactoryImpl.java	(revision 511)
@@ -91,4 +91,5 @@
 			case SysmlPackage.MODELICA_CONNECTION: return createModelicaConnection();
 			case SysmlPackage.MODELICA_CLASSIFIER: return createModelicaClassifier();
+			case SysmlPackage.MODELICA_PRIMITIVE_TYPE: return createModelicaPrimitiveType();
 			default:
 				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
@@ -441,4 +442,14 @@
 	 * @generated
 	 */
+	public ModelicaPrimitiveType createModelicaPrimitiveType() {
+		ModelicaPrimitiveTypeImpl modelicaPrimitiveType = new ModelicaPrimitiveTypeImpl();
+		return modelicaPrimitiveType;
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
 	public FlowDirection createFlowDirectionFromString(EDataType eDataType, String initialValue) {
 		FlowDirection result = FlowDirection.get(initialValue);
Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/SysmlPackageImpl.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/SysmlPackageImpl.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/impl/SysmlPackageImpl.java	(revision 511)
@@ -41,4 +41,5 @@
 import org.modelica.uml.sysml.ModelicaInteger;
 import org.modelica.uml.sysml.ModelicaModel;
+import org.modelica.uml.sysml.ModelicaPrimitiveType;
 import org.modelica.uml.sysml.ModelicaProperty;
 import org.modelica.uml.sysml.ModelicaReal;
@@ -271,4 +272,11 @@
 	 */
 	private EClass modelicaClassifierEClass = null;
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	private EClass modelicaPrimitiveTypeEClass = null;
 
 	/**
@@ -597,4 +605,13 @@
 	 * @generated
 	 */
+	public EReference getModelicaType_TypeData() {
+		return (EReference)modelicaTypeEClass.getEStructuralFeatures().get(0);
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
 	public EClass getModelicaReal() {
 		return modelicaRealEClass;
@@ -930,13 +947,4 @@
 	 * @generated
 	 */
-	public EReference getModelicaProperty_DataType() {
-		return (EReference)modelicaPropertyEClass.getEStructuralFeatures().get(6);
-	}
-
-	/**
-	 * <!-- begin-user-doc -->
-	 * <!-- end-user-doc -->
-	 * @generated
-	 */
 	public EClass getModelicaConnectorProperty() {
 		return modelicaConnectorPropertyEClass;
@@ -1031,4 +1039,13 @@
 	public EClass getModelicaClassifier() {
 		return modelicaClassifierEClass;
+	}
+
+	/**
+	 * <!-- begin-user-doc -->
+	 * <!-- end-user-doc -->
+	 * @generated
+	 */
+	public EClass getModelicaPrimitiveType() {
+		return modelicaPrimitiveTypeEClass;
 	}
 
@@ -1134,4 +1151,5 @@
 
 		modelicaTypeEClass = createEClass(MODELICA_TYPE);
+		createEReference(modelicaTypeEClass, MODELICA_TYPE__TYPE_DATA);
 
 		modelicaRealEClass = createEClass(MODELICA_REAL);
@@ -1182,5 +1200,4 @@
 		createEAttribute(modelicaPropertyEClass, MODELICA_PROPERTY__ARRAY_DIMENSION);
 		createEAttribute(modelicaPropertyEClass, MODELICA_PROPERTY__ACCESS);
-		createEReference(modelicaPropertyEClass, MODELICA_PROPERTY__DATA_TYPE);
 
 		modelicaConnectorPropertyEClass = createEClass(MODELICA_CONNECTOR_PROPERTY);
@@ -1199,4 +1216,6 @@
 
 		modelicaClassifierEClass = createEClass(MODELICA_CLASSIFIER);
+
+		modelicaPrimitiveTypeEClass = createEClass(MODELICA_PRIMITIVE_TYPE);
 
 		// Create enums
@@ -1247,10 +1266,9 @@
 		flowSpecificationEClass.getESuperTypes().add(theUMLPackage.getInterface());
 		itemFlowEClass.getESuperTypes().add(theUMLPackage.getInformationFlow());
-		modelicaTypeEClass.getESuperTypes().add(theUMLPackage.getPrimitiveType());
 		modelicaTypeEClass.getESuperTypes().add(this.getModelicaClassifier());
-		modelicaRealEClass.getESuperTypes().add(this.getModelicaType());
-		modelicaIntegerEClass.getESuperTypes().add(this.getModelicaType());
-		modelicaStringEClass.getESuperTypes().add(this.getModelicaType());
-		modelicaBooleanEClass.getESuperTypes().add(this.getModelicaType());
+		modelicaRealEClass.getESuperTypes().add(this.getModelicaPrimitiveType());
+		modelicaIntegerEClass.getESuperTypes().add(this.getModelicaPrimitiveType());
+		modelicaStringEClass.getESuperTypes().add(this.getModelicaPrimitiveType());
+		modelicaBooleanEClass.getESuperTypes().add(this.getModelicaPrimitiveType());
 		modelicaClassEClass.getESuperTypes().add(this.getBlock());
 		modelicaClassEClass.getESuperTypes().add(this.getModelicaClassifier());
@@ -1267,4 +1285,6 @@
 		modelicaConnectionEClass.getESuperTypes().add(theUMLPackage.getConnector());
 		modelicaClassifierEClass.getESuperTypes().add(theUMLPackage.getClassifier());
+		modelicaPrimitiveTypeEClass.getESuperTypes().add(theUMLPackage.getPrimitiveType());
+		modelicaPrimitiveTypeEClass.getESuperTypes().add(this.getModelicaClassifier());
 
 		// Initialize classes and features; add operations and parameters
@@ -1306,4 +1326,5 @@
 
 		initEClass(modelicaTypeEClass, ModelicaType.class, "ModelicaType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
+		initEReference(getModelicaType_TypeData(), theUMLPackage.getPrimitiveType(), null, "typeData", null, 0, 1, ModelicaType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
 
 		initEClass(modelicaRealEClass, ModelicaReal.class, "ModelicaReal", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
@@ -1335,5 +1356,5 @@
 
 		initEClass(modelicaClassEClass, ModelicaClass.class, "ModelicaClass", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
-		initEAttribute(getModelicaClass_IsEncapsulatedClass(), theUMLPackage.getBoolean(), "isEncapsulatedClass", null, 0, 1, ModelicaClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
+		initEAttribute(getModelicaClass_IsEncapsulatedClass(), theUMLPackage.getBoolean(), "isEncapsulatedClass", "", 0, 1, ModelicaClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
 
 		initEClass(modelicaModelEClass, ModelicaModel.class, "ModelicaModel", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
@@ -1354,5 +1375,4 @@
 		initEAttribute(getModelicaProperty_ArrayDimension(), theUMLPackage.getString(), "arrayDimension", null, 0, 1, ModelicaProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
 		initEAttribute(getModelicaProperty_Access(), this.getAccessKind(), "access", null, 0, 1, ModelicaProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
-		initEReference(getModelicaProperty_DataType(), this.getModelicaClassifier(), null, "dataType", null, 0, 1, ModelicaProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
 
 		initEClass(modelicaConnectorPropertyEClass, ModelicaConnectorProperty.class, "ModelicaConnectorProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
@@ -1372,4 +1392,6 @@
 		initEClass(modelicaClassifierEClass, ModelicaClassifier.class, "ModelicaClassifier", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
 
+		initEClass(modelicaPrimitiveTypeEClass, ModelicaPrimitiveType.class, "ModelicaPrimitiveType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
+
 		// Initialize enums and add enum literals
 		initEEnum(flowDirectionEEnum, FlowDirection.class, "FlowDirection");
Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/util/SysmlAdapterFactory.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/util/SysmlAdapterFactory.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/util/SysmlAdapterFactory.java	(revision 511)
@@ -193,4 +193,7 @@
 				return createModelicaClassifierAdapter();
 			}
+			public Object caseModelicaPrimitiveType(ModelicaPrimitiveType object) {
+				return createModelicaPrimitiveTypeAdapter();
+			}
 			public Object caseEModelElement(EModelElement object) {
 				return createEModelElementAdapter();
@@ -728,4 +731,18 @@
 
 	/**
+	 * Creates a new adapter for an object of class '{@link org.modelica.uml.sysml.ModelicaPrimitiveType <em>Modelica Primitive Type</em>}'.
+	 * <!-- begin-user-doc -->
+	 * This default implementation returns null so that we can easily ignore cases;
+	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
+	 * <!-- end-user-doc -->
+	 * @return the new adapter.
+	 * @see org.modelica.uml.sysml.ModelicaPrimitiveType
+	 * @generated
+	 */
+	public Adapter createModelicaPrimitiveTypeAdapter() {
+		return null;
+	}
+
+	/**
 	 * Creates a new adapter for an object of class '{@link org.eclipse.emf.ecore.EModelElement <em>EModel Element</em>}'.
 	 * <!-- begin-user-doc -->
Index: trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/util/SysmlSwitch.java
===================================================================
--- trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/util/SysmlSwitch.java	(revision 492)
+++ trunk/org.modelica.uml.sysml/src/org/modelica/uml/sysml/util/SysmlSwitch.java	(revision 511)
@@ -337,7 +337,5 @@
 				ModelicaType modelicaType = (ModelicaType)theEObject;
 				Object result = caseModelicaType(modelicaType);
-				if (result == null) result = casePrimitiveType(modelicaType);
 				if (result == null) result = caseModelicaClassifier(modelicaType);
-				if (result == null) result = caseDataType(modelicaType);
 				if (result == null) result = caseClassifier(modelicaType);
 				if (result == null) result = caseNamespace(modelicaType);
@@ -356,5 +354,5 @@
 				ModelicaReal modelicaReal = (ModelicaReal)theEObject;
 				Object result = caseModelicaReal(modelicaReal);
-				if (result == null) result = caseModelicaType(modelicaReal);
+				if (result == null) result = caseModelicaPrimitiveType(modelicaReal);
 				if (result == null) result = casePrimitiveType(modelicaReal);
 				if (result == null) result = caseModelicaClassifier(modelicaReal);
@@ -376,5 +374,5 @@
 				ModelicaInteger modelicaInteger = (ModelicaInteger)theEObject;
 				Object result = caseModelicaInteger(modelicaInteger);
-				if (result == null) result = caseModelicaType(modelicaInteger);
+				if (result == null) result = caseModelicaPrimitiveType(modelicaInteger);
 				if (result == null) result = casePrimitiveType(modelicaInteger);
 				if (result == null) result = caseModelicaClassifier(modelicaInteger);
@@ -396,5 +394,5 @@
 				ModelicaString modelicaString = (ModelicaString)theEObject;
 				Object result = caseModelicaString(modelicaString);
-				if (result == null) result = caseModelicaType(modelicaString);
+				if (result == null) result = caseModelicaPrimitiveType(modelicaString);
 				if (result == null) result = casePrimitiveType(modelicaString);
 				if (result == null) result = caseModelicaClassifier(modelicaString);
@@ -416,5 +414,5 @@
 				ModelicaBoolean modelicaBoolean = (ModelicaBoolean)theEObject;
 				Object result = caseModelicaBoolean(modelicaBoolean);
-				if (result == null) result = caseModelicaType(modelicaBoolean);
+				if (result == null) result = caseModelicaPrimitiveType(modelicaBoolean);
 				if (result == null) result = casePrimitiveType(modelicaBoolean);
 				if (result == null) result = caseModelicaClassifier(modelicaBoolean);
@@ -679,4 +677,23 @@
 				return result;
 			}
+			case SysmlPackage.MODELICA_PRIMITIVE_TYPE: {
+				ModelicaPrimitiveType modelicaPrimitiveType = (ModelicaPrimitiveType)theEObject;
+				Object result = caseModelicaPrimitiveType(modelicaPrimitiveType);
+				if (result == null) result = casePrimitiveType(modelicaPrimitiveType);
+				if (result == null) result = caseModelicaClassifier(modelicaPrimitiveType);
+				if (result == null) result = caseDataType(modelicaPrimitiveType);
+				if (result == null) result = caseClassifier(modelicaPrimitiveType);
+				if (result == null) result = caseNamespace(modelicaPrimitiveType);
+				if (result == null) result = caseRedefinableElement(modelicaPrimitiveType);
+				if (result == null) result = caseType(modelicaPrimitiveType);
+				if (result == null) result = caseTemplateableElement(modelicaPrimitiveType);
+				if (result == null) result = caseNamedElement(modelicaPrimitiveType);
+				if (result == null) result = casePackageableElement(modelicaPrimitiveType);
+				if (result == null) result = caseElement(modelicaPrimitiveType);
+				if (result == null) result = caseParameterableElement(modelicaPrimitiveType);
+				if (result == null) result = caseEModelElement(modelicaPrimitiveType);
+				if (result == null) result = defaultCase(theEObject);
+				return result;
+			}
 			default: return defaultCase(theEObject);
 		}
@@ -1134,4 +1151,19 @@
 
 	/**
+	 * Returns the result of interpretting the object as an instance of '<em>Modelica Primitive Type</em>'.
+	 * <!-- begin-user-doc -->
+	 * This implementation returns null;
+	 * returning a non-null result will terminate the switch.
+	 * <!-- end-user-doc -->
+	 * @param object the target of the switch.
+	 * @return the result of interpretting the object as an instance of '<em>Modelica Primitive Type</em>'.
+	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
+	 * @generated
+	 */
+	public Object caseModelicaPrimitiveType(ModelicaPrimitiveType object) {
+		return null;
+	}
+
+	/**
 	 * Returns the result of interpretting the object as an instance of '<em>EModel Element</em>'.
 	 * <!-- begin-user-doc -->
